Description

As a RHEV user, it would be nice to have the option between thin provisioned disks, and preallocated disks when creating VM's

using the oVirt API.

I've tested with Foreman 1.4.2, and RHEV 3.2.  There is no option presented when creating a disk, and the disk is created by default

as Thin.

Related issues:

Related to Foreman - Bug #9932: Setting 'Preallocate disk' flag for oVirt com... Closed 03/27/2015

Has duplicate Foreman - Bug #5086: Virtual machines in ovirt are created with... Duplicate 04/07/2014

Has duplicate Foreman - Feature #1854: Support non thin provisoned disk with ... Duplicate 09/06/2012

Associated revisions

Revision 2bf991a8 - 07/10/2014 11:44 AM - Leon Strong

fixes #5197 - Preallocated disk support for oVirt

History

#1 - 04/15/2014 02:16 PM - Dominic Cleal

- Category set to Compute resources

#2 - 05/12/2014 12:45 AM - Leon Strong

Just on this, as far as i'm able to tell, i've not found an easy way to allow this, those users (myself included) that have thin provisioning on their san

backends are in for a world of pain if they can't pre-allocate VM disks. :\

#3 - 05/12/2014 02:50 PM - Nathan Lager

If this helps, I've worked through doing this via he API. I have a perl script which i've used in the past to allocate vm's from templates. I managed to

piece together the following disk allocation xml, based on Red Hat's API docs.

<disk>

<clone>true</clone>

<storage_domains>

<storage_domain id=\\"%s\\"/></storage_domains>

<size>%s</size>

<type>system</type>

<interface>virtio</interface>

<format>RAW</format>

<bootable>true</bootable>

</disk>

The format = RAW flag is the key.  That tells the API to create this disk as a preallocated type, and not a thin disk.

This should be possible via foreman.  I'd guess it depends on whatever library foreman uses to interact with the oVirt API.

#4 - 05/15/2014 11:33 AM - Dominic Cleal
- Has duplicate Bug #5086: Virtual machines in ovirt are created with "Thin provision" disks added

#5 - 05/15/2014 11:34 AM - Dominic Cleal

- Has duplicate Feature #1854: Support non thin provisoned disk with oVirt added

#6 - 05/19/2014 08:21 PM - Dwight Anderson

It looks like the functionality for this is there in the underlying code base, the default behavior comes from the rbovirt gems

rbovirt-0.0.21/lib/ovirt/volume.rb which sets format to cow and sparse to true when no settings are being passed for those variables.  The system

should just need to be modified to pass the additional options for format and sparse as a part of the disk information sent by the web interface when

requesting a new disk.

#7 - 05/21/2014 12:55 PM - Dominic Cleal

- Status changed from New to Ready For Testing

- Assignee set to Amos Benari

- Target version set to 1.8.2

https://github.com/theforeman/foreman/pull/1462

#8 - 06/11/2014 02:56 PM - Anonymous

- Target version changed from 1.8.2 to 1.8.1

#9 - 06/11/2014 03:04 PM - Nathan Lager

I see the status sitting at ready for testing.

Are you waiting for someone to test?  If so, i'd be willing to do what I can.  What's involved in getting the proper version of code running to test?

Thanks!

#10 - 06/11/2014 03:10 PM - Dominic Cleal

Nathan Lager wrote:

I see the status sitting at ready for testing.

Are you waiting for someone to test?  If so, i'd be willing to do what I can.  What's involved in getting the proper version of code running to test?

 Yep, that'd be a great help.

You can do something like: cd /usr/share/foreman && curl https://github.com/theforeman/foreman/pull/1462.patch | patch -p1 and then restart

Foreman/httpd.

#11 - 06/11/2014 05:29 PM - Nathan Lager

Dominic Cleal wrote:

Nathan Lager wrote:

I see the status sitting at ready for testing.

Are you waiting for someone to test?  If so, i'd be willing to do what I can.  What's involved in getting the proper version of code running to

test?

 Yep, that'd be a great help.

You can do something like: cd /usr/share/foreman && curl https://github.com/theforeman/foreman/pull/1462.patch | patch -p1 and then restart

Foreman/httpd.

 Thanks!  I'll see if I can give that a shot without affecting my production foreman.  Give me some time to work out the best way to do that, and I'll

report back with the outcome.

#12 - 06/11/2014 06:39 PM - Nathan Lager

ok, I gave it a shot.  Close, but Foreman was unable to create my vm's disk.

It gave me the option to preallocate the disk, but when I submitted it, it failed while creating the instance, with the following error:
Unable to save

Failed to create a compute Metal (oVirt) instance testprov-nonthin.dev.lafayette.edu: Cannot add Virtual Machine Disk. Disk configuration (COW

Preallocated) is incompatible with the storage domain type.

The Storage domain is a RHEV Storage Pool, Fibre channel attached.  Let me know what other info you need in order to troubleshoot.

Thanks!

#13 - 07/07/2014 07:21 AM - Anonymous

- Target version changed from 1.8.1 to 1.8.0

#14 - 07/07/2014 05:44 PM - Leon Strong

i've created a pull request that should satisfy this if someone wants to test it, based off the previous pull request. 

https://github.com/theforeman/foreman/pull/1568/files

Hope this isn't breaking etiquette or something, I really need this in mainline asap.

I've verified it working against my RHEV cluster.

#15 - 07/07/2014 05:51 PM - Leon Strong

One thing of interest, in my development environment, I notice that the machine provisions fine, but it sometimes get rolled back after as it times out

whilst waiting to power up the machine (as the disks are still locked on the rhev side), not sure what the best path forward for that is. (I just don't

enable powering on the machine when thick provisioning).

Thoughts?

#16 - 07/08/2014 07:12 AM - Lukas Zapletal

Known issue, locked volumes seems to be problematic.

#17 - 07/10/2014 11:37 AM - Dominic Cleal

- Assignee changed from Amos Benari to Leon Strong

- translation missing: en.field_release set to 10

#18 - 07/10/2014 12:01 PM - Leon Strong

- Status changed from Ready For Testing to Closed

- % Done changed from 0 to 100

Applied in changeset 2bf991a88ea3cf4493b6da0521fa64a94ddb42a2.

#19 - 07/22/2014 06:28 AM - The Foreman Bot

- Pull request https://github.com/theforeman/foreman/pull/1462 added

- Pull request deleted ()

#20 - 01/08/2016 02:51 PM - Checheta Yan

Spam removed by Redmine administrator

#21 - 03/08/2016 07:46 AM - Marek Hulán

- Pull request https://github.com/theforeman/foreman/pull/1573 added

- Pull request deleted (https://github.com/theforeman/foreman/pull/1462)

Different PR was used to fix this issue.

#22 - 03/08/2016 08:17 AM - Marek Hulán

- Related to Bug #9932: Setting 'Preallocate disk' flag for oVirt compute profile does not stick added
